﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Master
{
    class Program
    {
        // ma se siplex zobrazit? - ANO: true, NE: false
        private static bool _isFastSimplex = false;
        private static TxtFileIO.TaskType type = TxtFileIO.TaskType.MAX;

        // barvy
        private static ConsoleColor dop1Color = ConsoleColor.White; // barva zvyrazneni
        private static ConsoleColor dop2Color = ConsoleColor.Gray; // nezvyraznena barva

        static void Main(string[] args)
        {
            Console.WindowHeight = 40; // zvetseni velikosti okna konzole

            // definice promennych
            double[] Z = { 45, 30, 15, 12 };
            double[,] A = { { 1, 1, 0, 0 }, { 2, 1, 0, 0 }, { 1, 1, 5, 2 }, { 2, 1, 1, 4 } };
            double[] b = { 80, 100, 120, 160 };

            // nacteni zadani ze 'zadani.txt'
            TxtFileIO.ReadInput("zadani.txt", out Z, out A, out b, out type);

            // rozctvrceni matice omezeni pro DOP1 a DOP2
            double[,] A1; double[,] A2;
            double[,] A3; double[,] A4;
            MatrixHelper.QuartersOfMatrix(A, out A1, out A2, out A3, out A4);

            #region DOP1
            ///// DOP1
            ////
            Console.ForegroundColor = dop2Color;
            Console.WriteLine("==================================");
            Console.ForegroundColor = dop1Color;
            Console.WriteLine(" * * * * * DOP1 * * * * * * * * *");
            Console.ForegroundColor = dop2Color;
            Console.WriteLine("==================================");

            // prvni polovina ucelove fce Z
            double[] pZ1 = MatrixHelper.HalfOfVector(Z);
            // prvni polovina prave strany omezeni b
            double[] pb1 = MatrixHelper.HalfOfVector(b);

            // ulozeni dat pro vypocet simplexovy metody
            TxtFileIO.Save("dataDOP1.txt", pZ1, A1, pb1);

            // spusteni simplexove metody: SimplexMethod.exe
            runSimpexMethod("dataDOP1.txt", "vysledekDOP1.txt");

            // definice promennych vysledku DOP2
            double[] x1;
            double Z1op;

            // nacteni vyslednych hodnot DOP1
            TxtFileIO.Load("vysledekDOP1.txt", out x1, out Z1op);

            // vypsani vysledku DOP1
            int i1 = 1;
            foreach (var x in x1)
            {
                //Console.WriteLine("x[" + i1 + "] = " + x);
                Console.ForegroundColor = ConsoleColor.Yellow;
                Console.Write(" x[" + i1 + "] ");
                Console.ResetColor();
                Console.Write("= ");
                Console.ForegroundColor = ConsoleColor.Green;
                Console.WriteLine(x);
                i1++;
            }
            Console.ForegroundColor = dop2Color;
            Console.WriteLine("==================================");
            Console.ForegroundColor = dop2Color;
            Console.WriteLine(" vysledek DOP1 = " + Z1op);
            Console.ForegroundColor = dop2Color;
            Console.WriteLine("==================================\n");
            #endregion


            #region DOP2
            ///// DOP2
            ////
            Console.ForegroundColor = dop2Color;
            Console.WriteLine("==================================");
            Console.ForegroundColor = dop1Color;
            Console.WriteLine(" * * * * * DOP2 * * * * * * * * *");
            Console.ForegroundColor = dop2Color;
            Console.WriteLine("==================================");
            // druha polovina ucelove fce Z
            double[] pZ3 = MatrixHelper.HalfOfVector(Z, true);
            // druha polovina prave strany omezeni b
            double[] pb3 = MatrixHelper.HalfOfVector(b, true);

            //// prepocet pro DOP2
            // vynasobeni vsech radku A3 vysledymi x z "x1" z DOP1
            double[] vec = MatrixHelper.MultipleByVectorAndSumIt(A3, x1);

            //// odecteni od pb3 hodnoty vektoru vek
            // priklad: 120 - 80 =  40 a 160 - 60 = 100 ---> bNew = { 40, 100 }
            double[] b2 = MatrixHelper.SubtractionTwoVectors(pb3, vec);

            // ulozeni dat pro vypocet simplexovy metody
            TxtFileIO.Save("dataDOP2.txt", pZ3, A4, b2);

            // spusteni simplexove metody: SimplexMethod.exe
            runSimpexMethod("dataDOP2.txt", "vysledekDOP2.txt");

            // definice promennych vysledku DOP2
            double[] x2;
            double Z2op;

            // nacteni vyslednych hodnot DOP1
            TxtFileIO.Load("vysledekDOP2.txt", out x2, out Z2op);

            // vypsani vysledku DOP1
            int i2 = 1;
            //Console.WriteLine("==================================");
            foreach (var x in x2)
            {
                //Console.WriteLine("x[" + i2 + "] = " + x);
                Console.ForegroundColor = ConsoleColor.Yellow;
                Console.Write(" x[" + i2 + "] ");
                Console.ResetColor();
                Console.Write("= ");
                Console.ForegroundColor = ConsoleColor.Green;
                Console.WriteLine(x);
                i2++;
            }
            Console.ForegroundColor = dop2Color;
            Console.WriteLine("==================================");
            Console.ForegroundColor = dop2Color;
            Console.WriteLine(" vysledek DOP2 = " + Z2op);
            Console.ForegroundColor = dop2Color;
            Console.WriteLine("==================================");
            Console.ResetColor();
            #endregion

            #region DOP = DOP1 + DOP2
            ///// DOP1 + DOP2
            ////
            // soucet vysledku DOP1 + DOP2
            double Zop = Z1op + Z2op;

            // vypis vysledku
            Console.ForegroundColor = dop1Color;
            Console.Write("\n==================================" +
                              "\n Vysledek DOP: ");
            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("Z(optimalni)");
            Console.ResetColor();
            Console.Write(" = ");
            Console.ForegroundColor = ConsoleColor.Green;
            Console.WriteLine(Zop);
            Console.ForegroundColor = dop1Color;
            Console.Write("==================================\n"); 
            #endregion

            // ukoncit proces 'Master'
            Console.ForegroundColor = ConsoleColor.Red;
            Console.WriteLine("\n Ukoncete stisknutim klavesy Enter.");
            Console.ReadKey();
        }

        #region metoda pro spusteni SimplexMethod.exe
        private static void runSimpexMethod(string txtIn, string txtOut)
        {
            try
            {
                var proc = new Process();
                proc.StartInfo.FileName = _isFastSimplex ? "FastSimplexMethod.exe" : "SimplexMethod.exe";
                proc.StartInfo.Arguments = txtIn + " " + txtOut + " " + type;
                proc.Start();
                proc.WaitForExit();
                Console.ForegroundColor = ConsoleColor.Gray;
                Console.WriteLine(" Probehl vypocet Simplexove metody.");
                Console.WriteLine("==================================");
                Console.ResetColor();
                proc.Close();
            }
            catch (Exception) 
            {
                Console.WriteLine("CHYBA: Nastala chyba v resici Simplexove metody, je poskozen, nebo ve zdrojovem adresari chybi.");
            }
        } 
        #endregion
    }
}