﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SimplexMethod
{
    class Program
    {
        //// deklarace promennych
        private static double[] Z;
        private static double[,] A;
        private static double[] b;
        private static SimplexType SimplexType = SimplexType.MAXIMAZE;

        static void Main(string[] args)
        {
            // deklarace z argumentu - nazev souboru se zadanim (defaultne: test.txt)
            var txtFileIn = (args.Length > 0) ? args[0] : "dataDOP1.txt";
            // deklarace z argumentu - nazev souboru k ulozeni vyslednych hodnot
            var txtFileOut = (args.Length > 1) ? args[1] : "defult.txt";
            // deklarace z argumentu - typ ulohy Symplexove metody  (defaultne: MAX)
            var taskType = (args.Length > 2) ? args[2] : "MAX";
            // typ ulohy Symplexove metody: Maximalizacni/Minimalizacni  (defaultne: Maximalizacni)
            SimplexType = (taskType == "MIN") ? SimplexType.MINIMAZE : SimplexType.MAXIMAZE;

            // rovnitka omezujicich (ne)rovnic (mensi/vetsi/rovno)
            ConstraintOperator op = ConstraintOperator.LESS_THAN;

            //// nacteni zadani od programu Master // TODO: odkomentuj pro Mastra
            TxtFileIO.Load(txtFileIn, out Z, out A, out b);

            //// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
            #region Ulohy "naTvrdo"
            ////// ULOHA_1: DOP1
            ////ucelova fce Z = [pocet_promennych] { nasobky}
            //double[] Z = { 45, 30 };
            //// zadani omezujicich (ne)rovnic - matice [radky, sloupce] {hodnoty}
            //double[,] A = { { 1, 1 }, { 2, 1 } };
            //// rovnitka (ne)rovnic + ucelove fce (mensi/vetsi/rovno)
            //// vysledne hodnoty omezujicich (ne)rovnic
            //double[] b = { 80, 100 };

            ////// ULOHA_1: DOP2
            //// ucelova fce Z = [pocet_promennych] {nasobky}
            //double[] Z = new double[2] { 15, 12 };
            //// zadani omezujicich (ne)rovnic - matice [radky, sloupce] {hodnoty}
            //double[,] A = new double[2, 2] { { 5, 2 }, { 1, 4 } };
            //// vysledne hodnoty omezujicich (ne)rovnic
            //double[] b = new double[2] { 40, 60 };

            ////// ULOHA_2: DOP1
            //// ucelova fce Z = [pocet_promennych] {nasobky}
            //double[] Z = new double[4] { 59.9, 47.4, 59.7, 52.9, };
            //// zadani omezujicich (ne)rovnic - matice [radky, sloupce] {hodnoty}
            //double[,] A = new double[5, 4] { { 2.3, 1.9, 1.7, 1.7 }, { 1.3, 1.3, 2.2, 2.7 }, { 1.5, 2.3, 2.6, 1.6 }, { 1.2, 2.0, 1.3, 2.7 }, { 1.5, 1.6, 2.2, 2.4 } };
            //// vysledne hodnoty omezujicich (ne)rovnic
            //double[] b = new double[5] { 83, 97, 91, 86, 86 };

            ////// ULOHA_2: DOP FULL
            //// ucelova fce Z = [pocet_promennych] {nasobky}
            //double[] Z = new double[8] { 59.9, 47.4, 59.7, 52.9, 11.3, 16.4, 11.6, 12.5 };
            //// zadani omezujicich (ne)rovnic - matice [radky, sloupce] {hodnoty}
            //double[,] A = new double[10, 8] { { 2.3, 1.9, 1.7, 1.7, 0.0, 0.0, 0.0, 0.0 }, { 1.3, 1.3, 2.2, 2.7, 0.0, 0.0, 0.0, 0.0 }, { 1.5, 2.3, 2.6, 1.6, 0.0, 0.0, 0.0, 0.0 }, { 1.2, 2.0, 1.3, 2.7, 0.0, 0.0, 0.0, 0.0 }, { 1.5, 1.6, 2.2, 2.4, 0.0, 0.0, 0.0, 0.0 },
            //                                  { 2.3, 1.9, 1.7, 1.7, 4.3, 3.9, 3.8, 3.2 }, { 1.3, 1.3, 2.2, 2.7, 3.6, 3.1, 3.7, 3.4 }, { 1.5, 2.3, 2.6, 1.6, 4.3, 4.1, 4.5, 3.6 }, { 1.2, 2.0, 1.3, 2.7, 4.3, 4.5, 4.3, 3.6 }, { 1.5, 1.6, 2.2, 2.4, 3.2, 3.2, 4.3, 4.1 } };
            //// vysledne hodnoty omezujicich (ne)rovnic
            //double[] b = new double[10] { 83, 97, 91, 86, 86, 129, 134, 154, 123, 140 };
            #endregion
            //// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

            // resic Simplex metody pro primo zadane priklady
            SimplexMethodSolver solver = new SimplexMethodSolver(A, b, op, Z, SimplexType);
            solver.solve();

            // vypsani dilcich vysledku x[i] (i = 1, 2, ..., n)
            //Console.ForegroundColor = ConsoleColor.Yellow;
            Console.WriteLine("===================================================================================================\n");
            double[] x = solver.getSolutionVector();
            for (int i = 0; i < x.Length; i++)
            {
                //Console.WriteLine("x[" + i + "] = " + x[i]);
                Console.ForegroundColor = ConsoleColor.Yellow;
                Console.Write("x[" + i + "] ");
                Console.ResetColor();
                Console.Write("= ");
                Console.ForegroundColor = ConsoleColor.Green;
                Console.WriteLine(x[i]);
            }

            // vysledna optimalni hodnota Z(optimalni)
            double Zopt = solver.getValue();

            //// vypsani vysledne optimalni hodnoty
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("Vysledne reseni ");
            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("Z(optimalni) ");
            Console.ResetColor();
            Console.Write("= ");
            Console.ForegroundColor = ConsoleColor.Green;
            Console.WriteLine(Zopt);

            // ulozeni vysledku do souboru .txt
            TxtFileIO.Save(txtFileOut, x, Zopt);

            // ukoncit program stisknutim klavesy
            Console.ReadLine();
        }
    }
}
